""" Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end """
import json, requests
from django.conf import settings
from cshmac.requests import HmacAuth
from requests.packages.urllib3.exceptions import InsecureRequestWarning
from sealab.utils import maybe_json_or_raise
from urllib.parse import quote_plus
requests.packages.urllib3.disable_warnings(InsecureRequestWarning)

def find_indicators(iri, indicator_type, indicator_reputation):
    query_url = 'https://localhost{0}/indicators'
    query_url = query_url.format(iri)
    if indicator_type or indicator_reputation:
        query_url +='?'
    if indicator_type:
        query_url += 'typeofindicator__itemValue$eq={0}'.format(quote_plus(indicator_type))
    if indicator_reputation:
        query_url += '&reputation__itemValue$eq={0}'.format(quote_plus(indicator_reputation))
    response = _make_api_call(query_url, 'GET')
    indicator_list = response.get('hydra:member')
    return indicator_list

def _make_api_call(url, method, headers=None, body=None):
    APPLIANCE_PUBLIC_KEY = settings.APPLIANCE_PUBLIC_KEY
    APPLIANCE_PRIVATE_KEY = settings.APPLIANCE_PRIVATE_KEY
    body_payload = json.dumps(body) if body else APPLIANCE_PUBLIC_KEY
    auth = HmacAuth(url, method, APPLIANCE_PUBLIC_KEY, APPLIANCE_PRIVATE_KEY, body_payload)
    bodyless_methods = ['head', 'get']
    if method.lower() in bodyless_methods:
        body_payload = None
    response = requests.request(method, url, auth=auth, json=body, verify=False)
    return maybe_json_or_raise(response)
